
#define 	BIGLENGTH 		100000L

typedef struct {
  long length;		/* digits[length]>0; digits[length+1]==0 */
  long first;		/* digits[i] == 0; 0<=i<first		 */
  unsigned short digits[BIGLENGTH];
} bigint;

void	bi_const	(bigint *this);
void    bi_null		(bigint *this);
void    bi_one		(bigint *this);
void    bi_dest		(bigint *this);
bigint *bi_assign	(bigint *this, bigint *other);
bigint *bi_add		(bigint *this, bigint *other);
bigint *bi_mult_nnnn	(bigint *this, long ziffer);
bigint *bi_multiply	(bigint *dest, bigint *src1, bigint *src2);
bigint *bi_shift_left	(bigint *this, long stellen);
bigint *bi_mult_long	(bigint *this, long operand);
void    bi_output	(bigint *this, FILE *);
