#include <stdio.h>

void main (int argc, char *argv[])
{
  int d1, d2, z1l, z2l, z1f, z2f, prozessor, shift, l1, l2, o1, o2;
  int iprocs[16], index, iindex, iter1, iter2;
  int len1, len2;

  d1  = atoi (argv[1]);
  d2  = atoi (argv[2]);
  z1l = atoi (argv[3]);
  z2l = atoi (argv[4]);
  z1f = atoi (argv[5]);
  z2f = atoi (argv[6]);

  fprintf (stderr, "z1 has length %03d first %03d splitting in %03d parts.\n",z1l,z1f,d1);
  fprintf (stderr, "z2 has length %03d first %03d splitting in %03d parts.\n",z2l,z2f,d2);

  iindex = 0;
  for (iter1=d1-1; iter1>=0; iter1--) {
    for (iter2=d2-1; iter2>=0; iter2--) {
      len1 = (z1l - z1f) / d1 + 1;
      len2 = (z2l - z2f) / d2 + 1;

      prozessor    = iindex++;
      shift        = iter1 * len1 + iter2 * len2 + z1f + z2f;
      l1           = (iter1==d1-1)?(z1l-z1f-((d1-1)*len1)+1):len1;
      l2           = (iter2==d2-1)?(z2l-z2f-((d2-1)*len2)+1):len2;
      o1           = z1f + iter1 * len1;
      o2           = z2f + iter2 * len2;

      printf ("Proc %03d (%03d/%03d) Zahl1 %03d-%03d Zahl2 %03d-%03d Shift %03d\n",
              prozessor,
              iter1,
              iter2,
              o1, o1 + l1 - 1,
              o2, o2 + l2 - 1,
              shift);
    }
  }

  /*
   * Hope this was it
   */
  return;
}

